var events = require("events");
var util   = require("util");
var redis  = require("redis");
var uuid   = require("node-uuid");

var Worker = function (port, host, options) {
    if (!(this instanceof Worker)) return new Worker();
    Worker.super_.call(this);

    this.redis      = redis.createClient(port,host,options);
    this.job_queue  = redis.createClient(port,host,options);

    this.listen();
}

util.inherits(Worker,events.EventEmitter);

Worker.prototype.listen = function() {
    var self = this;
    self.job_queue.blpop("yajq:jobs", 0, function (err, res) {
        var packet = JSON.parse(res[1]);
        var next   = null;
        var params = null;

        if (typeof packet.params !== 'undefined') {
            params = packet.params;
        }
        if (typeof packet.job_id !== 'undefined') {
            next = function (error, response) {
                var r = {
                    'job_id'  : packet.job_id,
                    'error'   : error,
                    'response': response
                }
                self.redis.rpush("yajq:done:"+packet.caller_id, JSON.stringify(r));
            };
        }
        if (self.listeners(packet.name).length === 0) {
            next("unknown command");
        }
        else {
            self.emit(packet.name, params, next);
        }
        self.listen();
    });
};

exports.Worker = Worker;